'***************************************
'*  VGA 1280 x 1024 - luma/color bars  *
'***************************************

CON

  s = 44	'scales DAC output (s = 0..128)


DAT		org

		clkset #$FF			'set 80MHz

		reps	#64,#2			'start 8-bit incrementing sequence at $BB
		setspa	#$BB
		pusha	luma
		add	luma,lumad

		setctra	#%00111			'set ctra for PLL*8
                setfrqa	frqa_			'set frqa

		setvid	#%0100000		'set vid for vga output
		setvidy	vidy_			'set yiq coefficients
		setvidi	vidi_
		setvidq	vidq_

		cfgdacs	#%11_11_11_11		'set dacs to video mode
'
'
' Field loop
'
field           mov	x,#38			'top blanks
		call	#blank

                mov     y,lines_vis		'set visible lines
line	        call	#sync			'do horizontal sync
		waitvid	mode,#0			'256*5 clocks per waitvid - show luma/colorbars
	        djnz    y,#line           	'another line?

                mov     x,#1			'bottom blanks
		call	#blank

		setp	#0			'do vertical sync
		mov	x,#3
		call	#blank
		clrp	#0

                jmp     #field                  'field loop


blank		call	#sync			'blank lines
		waitvid	#1280,#0
		djnz	x,#blank
blank_ret	ret

sync						'horizontal sync
sync_ret	retd
		waitvid	#48,#0
		waitvid	#112,#1
		waitvid	#248,#0
'
'
' Initialized data
'
luma		long	$03020100
lumad		long	$04040404

frqa_		long	$2B33_3333		'108MHz @80MHz clock

vidy_		long	$00_01_00_00 * s	'red gain
vidi_		long	$00_00_01_00 * s	'green gain
vidq_		long	$00_00_00_01 * s	'blue gain

		'	color base	mode		clocks/pixel	clocks/waitvid
mode		long	$BB << 24 +	$A << 20 +	5 << 13 +	1280

lines_vis	long	1024

x		long	0
y		long	0
